"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.description = exports.params = exports.parseResponse = exports.url = exports.identifier = exports.fromSection = exports.isEndpointSection = exports.fromDocument = void 0;
const Cheerio = __importStar(require("cheerio"));
const F = __importStar(require("fp-ts/function"));
const Common = __importStar(require("./common"));
const O = __importStar(require("fp-ts/Option"));
const marked_1 = __importDefault(require("marked"));
const Structures = __importStar(require("./structures"));
const Arr = __importStar(require("fp-ts/Array"));
const fromDocument = (markdown) => markdown
    .replace(/\r\n/, "\n")
    .split(/(^|\n)##\s+/)
    .map((section) => section.split("\n"))
    .filter(exports.isEndpointSection)
    .map((section) => exports.fromSection(section));
exports.fromDocument = fromDocument;
const endpointR = /(.*) % (get|post|put|patch|delete) (.*)$/i;
const isEndpointSection = (section) => endpointR.test(section[0]);
exports.isEndpointSection = isEndpointSection;
const fromSection = (section) => {
    const markdown = `## ${section.join("\r\n")}`;
    const $ = Cheerio.load(marked_1.default(markdown));
    const match = section[0].match(endpointR);
    const route = exports.identifier(match[1]);
    const response = F.pipe(section.join(" ").match(/\breturns .*?\./gi), O.fromNullable, O.map((m) => m.join(" ")), O.map(exports.parseResponse));
    return {
        route,
        description: exports.description($),
        method: match[2],
        url: exports.url(match[3]),
        params: exports.params($, markdown, route, !/get|delete/i.test(match[2])),
        response,
    };
};
exports.fromSection = fromSection;
const identifier = (heading) => F.pipe(heading.trim(), Common.camelify);
exports.identifier = identifier;
const url = (raw) => raw.replace(/\{(.*?)\}/g, F.flow((_, param) => param.split("#")[0].replace(/[^A-z]/g, "_"), (param) => `{${param}}`));
exports.url = url;
const parseResponse = (markdown) => {
    const $ = Cheerio.load(marked_1.default(markdown));
    const ref = Structures.referenceFromLinks($("a"));
    const array = /array|list/.test(markdown);
    return {
        ref,
        array,
    };
};
exports.parseResponse = parseResponse;
const params = ($, markdown, route, hasBody) => {
    const takes = F.pipe(O.fromNullable(/\bTakes a.*?\./.exec(markdown)), O.map((matches) => matches[0]), O.map((md) => [Cheerio.load(marked_1.default(md)), /array|list/.test(md)]), O.chain(([$, array]) => F.pipe(Structures.referenceFromLinks($("a")), O.map((identifier) => ({
        identifier,
        array,
        structures: [],
    })))));
    return F.pipe(Structures.fromDocument($, /zzz/, /params/i), Arr.filter(({ identifier }) => hasBody ? !/querystring/i.test(identifier) : !/json/i.test(identifier)), Arr.map((structure) => {
        const identifier = Common.typeify(route);
        const variant = structure.identifier
            .replace(/json/i, "")
            .replace(/form/i, "")
            .replace(/querystring/i, "")
            .replace(/Params?/, "");
        return {
            ...structure,
            identifier: `${identifier}${variant}Params`,
        };
    }), O.fromPredicate((s) => s.length > 0), O.map((structures) => ({
        identifier: `${Common.typeify(route)}Params`,
        array: false,
        structures,
    })), O.alt(() => takes));
};
exports.params = params;
const description = ($) => F.pipe(O.some($("h2").next("p").first()), O.filter(($p) => $p.length > 0), O.map(($p) => $p.text().trim()));
exports.description = description;
